;;; coding: euc-jp
;;; -*- scheme -*-
;;; vim:set ft=scheme ts=8 sts=2 sw=2 et:
;;; $Id: dispatch-tir.scm 40 2009-05-09 12:11:50Z nekoie $

;;; cgi dispatch module

;;;   Copyright (c) 2005 atsuo yamada, All rights reserved.
;;;   
;;;   Redistribution and use in source and binary forms, with or without
;;;   modification, are permitted provided that the following conditions
;;;   are met:
;;;   
;;;   1. Redistributions of source code must retain the above copyright
;;;      notice, this list of conditions and the following disclaimer.
;;;  
;;;   2. Redistributions in binary form must reproduce the above copyright
;;;      notice, this list of conditions and the following disclaimer in the
;;;      documentation and/or other materials provided with the distribution.
;;;  
;;;   3. Neither the name of the authors nor the names of its contributors
;;;      may be used to endorse or promote products derived from this
;;;      software without specific prior written permission.
;;;  
;;;   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
;;;   "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
;;;   LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
;;;   A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
;;;   OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
;;;   SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
;;;   TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
;;;   PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
;;;   LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
;;;   NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
;;;   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

;;; WARN: ȥơ֥ϡ⥸塼ݻ롣ס
;;;       ⥸塼ޤϤǤʤա
;;;       ޤ⥸塼̾ƱȡͤƤޤˤա
;;;       module&cgi-entry->urlmodule&cgi-entry->html:formؿѤݤ
;;;       ȤΥ⥸塼Ϥ

;;; note: ǥѥå˥ơ֥롣Ť
;;; note: alist-table¸entityϡʲηpairȤʤ롣
;;;       (cons define-cgi-entry«̾ define-cgi-entryμ)
;;;       ʤΤǡǥХåκݤˤդ

;;; usage:
;;; - ʲΤ褦Ƥ
;;;   (define-cgi-entry (disp-cgi-menu ...) '(("cmd" "menu")) body...)
;;;   (define-cgi-entry disp-cgi-fallback '() disp-cgi-menu)
;;;   (define-cgi-entry (disp-cgi-hoge ...) '(("c" "a") ("submit" :*)) body...)
;;; - «̾bodyδ֤ˡalistˤtemplate꤬ʳϡ
;;;   ̾defineȰ㤤̵Х«ȤƤⰷ롣
;;; - ºݤ˥ǥѥåϡʲΤ褦ˤdefineƤФ
;;;   (let1 proc (cgi-params-dispatch cgi-params) ...)
;;; -- ǡcgi-params˥ޥåΤǤ롣
;;; -- (let1 proc (cgi-params-dispatch cgi-params fallback) ...)
;;;    Τ褦ˡŪfallbackꤹǽ
;;; --- ξǤ⡢template'()ꤵƤΤС
;;;     äͥ褵롣
;;; - templatealistͤ:*ꤹǡwildcardȤƻȤ롣
;;; - 嵭entryϡ(cgi-entry->url 'disp-cgi-menu)Ȥơ
;;;   ưפurlformꤹǤ롣
;;;   εǽȤСcgiץˡcgiѥ᡼ľꤹ
;;;   ʤǤ롣ʤȤ⡢̤ܤưפʬ褦ˤʤ롣


(define-module www.cgi.dispatch-tir
  (use srfi-1)
  (use srfi-2) ; and-let*

  (use text.tree)
  (use text.html-lite)
  (use rfc.uri)
  (use www.cgi)

  (use www.cgi.dispatch-tir.alist-table)

  (export
    ;; macro
    define-cgi-entry
    cgi-params-dispatch
    cgi-entry->url
    cgi-entry->html:form
    cgi-entry->html:a

    ;; cgi-entry->url cgi-entry->html:formˡapplyȤΰ٤Ρؿǡ
    ;; (apply module&cgi-entry->url (current-module) ...) Τ褦ˤƻȤ
    module&cgi-entry->url
    module&cgi-entry->html:form
    module&cgi-entry->html:a

    cgi-entry-name->template-alist
    get-dispatch-table ; for debug

    ;; deprecated
    cgi-entry->form
    module&cgi-entry->form
    ))
(select-module www.cgi.dispatch-tir)


(define *module->dispatch-table-table* (make-hash-table 'eq?))

(define (module->dispatch-table module)
  (hash-table-get *module->dispatch-table-table* module #f))


(define (add-dispatch-entry! module bind-name template entity)
  (unless (every
            (cut pair? <>)
            template)
    (errorf
      "define-cgi-entry's template must be alist. (module=~a bind=~a)"
      module
      bind-name))
  (alist-table-put!
    (or
      (module->dispatch-table module)
      (let1 new-table (make <alist-table>)
        (hash-table-put! *module->dispatch-table-table* module new-table)
        new-table))
    template
    (cons
      bind-name
      entity)))



;; :
;; - define-cgi-entryϡ̾defineȤƤⵡǽ롣
;; -- â̾δؿȤľܸƤ־ϡtemplateϻѤʤ
(define-syntax define-cgi-entry
  (syntax-rules ()
    ((_ (name . args) require-template . body)
     (define-cgi-entry name require-template (lambda args . body)))
    ((_ name require-template expr)
     (begin
       ;; ȥåץ٥define
       (define name expr)
       ;; ȥơ֥Ͽ
       ((with-module www.cgi.dispatch-tir add-dispatch-entry!)
         (current-module) 'name require-template name)))))



(define *dummy-fallback* (gensym))
;; note: alist-table-getη̤cdr֤ɬפ
(define (module&cgi-params->dispatch module cgi-params . opt-fallback)
  (let1 dispatch-table (module->dispatch-table module)
    (if dispatch-table
      (if (null? opt-fallback)
        (cdr (alist-table-get dispatch-table cgi-params))
        (let1 r (alist-table-get dispatch-table cgi-params *dummy-fallback*)
          (if (eq? r *dummy-fallback*)
            (car opt-fallback)
            (cdr r))))
      (if (null? opt-fallback)
        (error "no one cgi-entry are not defined")
        (car opt-fallback)))))


;; module&cgi-params->dispatchΥåѡ
(define-syntax cgi-params-dispatch
  (syntax-rules ()
    ((_ cgi-params . opt-fallback)
     ((with-module www.cgi.dispatch-tir module&cgi-params->dispatch)
       (current-module) cgi-params . opt-fallback))))





(define (module&cgi-entry->url module entry-name . keywords)
  (let-keywords* keywords ((base-url (self-url/path-info))
                           (params '()) ; ɲcgiѥ᡼
                           . #f)
    (let1 template (module&cgi-entry-name->template-alist module entry-name)
      (unless template
        (errorf "not found entry ~a" entry-name))
      (append-params-to-url
        base-url
        (append template params)))))

(define-syntax cgi-entry->url
  (syntax-rules ()
    ((_ entry-name . keywords)
     (module&cgi-entry->url (current-module) entry-name . keywords))))




(define (keywords-remove src-keywords . remove-list)
  (unless (even? (length src-keywords))
    (errorf "~s is not even" src-keywords))
  (let loop ((left src-keywords)
             (result '()))
    (if (null? left)
      result
      (let ((keyword (car left))
            (keyword-value (cadr left))
            (new-left (cddr left)))
        (loop
          new-left
          (if (memq keyword remove-list)
            result
            (list* keyword keyword-value result)))))))




(define (module&cgi-entry->html:form module entry-name . keywords)
  (let-keywords* keywords ((base-url (self-url/path-info))
                           (params '()) ; ɲcgiѥ᡼
                           (internal-html #f) ; html:formhtmlޤ#f
                           (submit-label "") ; internal-html#fλѥܥ
                           (method "post") ; methodϥǥեͤߤΤ
                           . #f)
    (let1 template (module&cgi-entry-name->template-alist module entry-name)
      (define (alist->hidden alist)
        (map
          (lambda (name+values)
            (let ((name (car name+values))
                  (values (cdr name+values)))
              (map
                (lambda (value)
                  (html:input
                    :type "hidden"
                    :name name
                    :value value))
                (if (list? values) values '("")))))
          alist))

      (unless template
        (errorf "not found entry ~a" entry-name))
      (tree->string
        (apply
          html:form
          :action base-url
          :method method
          (append
            (keywords-remove
              keywords :base-url :params :internal-html :submit-label :method)
            (list
              (alist->hidden template)
              (alist->hidden params)
              (if internal-html
                internal-html
                (html:input
                  :type "submit"
                  :value submit-label)))))))))

(define-syntax cgi-entry->html:form
  (syntax-rules ()
    ((_ entry-name . keywords)
     (module&cgi-entry->html:form (current-module) entry-name . keywords))))




(define (module&cgi-entry->html:a module entry-name . keywords)
  (let-keywords* keywords ((base-url (self-url/path-info))
                           (params '()) ; ɲcgiѥ᡼
                           ;(label base-url) ; urlƤ
                           . #f)
    (let* ((url (apply module&cgi-entry->url module entry-name keywords))
           (label (get-keyword :label keywords url))
           )
      (apply
        html:a
        :href url
        (append
          (keywords-remove keywords :base-url :params :label)
          (list
            (html-escape-string label)))))))

(define-syntax cgi-entry->html:a
  (syntax-rules ()
    ((_ entry-name . keywords)
     (module&cgi-entry->html:a (current-module) entry-name . keywords))))






(define (module&cgi-entry-name->template-alist module entry-name)
  (let1 dispatch-table (module->dispatch-table module)
    (alist-table-any
      dispatch-table
      (lambda (template bind-name+entity)
        (and
          (eq? entry-name (car bind-name+entity))
          template)))))

(define-syntax cgi-entry-name->template-alist
  (syntax-rules ()
    ((_ entry-name)
     ((with-module www.cgi.dispatch-tir module&cgi-entry-name->template-alist)
       (current-module) entry-name))))



;; for debug
(define-syntax get-dispatch-table
  (syntax-rules ()
    ((_)
     (hash-table-get
       (with-module www.cgi.dispatch-tir *module->dispatch-table-table*)
       (current-module)
       #f))))


;;; ----
;;; utility for cgi
;;; (came from tir02.cgi)



(define (append-params-to-url url params)
  (if (null? params)
    url
    (receive (url-without-fragment fragment) (let1 m (#/(\#.*)/ url)
                                               (if m
                                                 (values (m 'before) (m 1))
                                                 (values url "")))
      (call-with-output-string
        (lambda (p)
          (define delimiter
            (if (#/\?/ url-without-fragment)
              (lambda () "&")
              (lambda ()
                (set! delimiter (lambda () "&"))
                "?")))

          (display url-without-fragment p)
          (let loop ((left-params params))
            (if (null? left-params)
              (display fragment p)
              (let ((key-encoded (uri-encode-string (caar left-params)))
                    (vals (cdar left-params))
                    (next-left (cdr left-params))
                    )
                (for-each
                  (lambda (val)
                    (display (delimiter) p) ; "?" or "&"
                    (display key-encoded p)
                    (display "=" p)
                    (display (uri-encode-string (if (string? val) val "")) p))
                  (if (list? vals) vals '("")))
                (loop next-left)))))))))


(define (completion-uri uri server-name server-port https)
  (receive (uri-scheme
            uri-userinfo
            uri-hostname
            uri-port
            uri-path
            uri-query
            uri-fragment)
    (uri-parse uri)
    ;; uri-scheme̵ˤ䴰
    ;; âserver-nameͿƤʤ䴰ǤʤΤǡ⤷ʤ
    (if (or uri-scheme (not server-name))
      uri
      (let* ((scheme (if https "https" "http"))
             (default-port (if https 443 80))
             )
        (uri-compose
          :scheme scheme
          :userinfo uri-userinfo
          :host server-name
          :port (and
                  server-port
                  (not (eqv? default-port (x->number server-port)))
                  server-port)
          :path uri-path
          :query uri-query
          :fragment uri-fragment)))))

(define (path->url path)
  (if (#/^\// path)
    (completion-uri
      path
      (cgi-get-metavariable "SERVER_NAME")
      (cgi-get-metavariable "SERVER_PORT")
      (cgi-get-metavariable "HTTPS"))
    path))

(define (self-url)
  (path->url (self-path)))
(define (self-url/path-info)
  (path->url (self-path/path-info)))

(define (self-path)
  (or (cgi-get-metavariable "SCRIPT_NAME") "/"))

(define (self-path/path-info)
  ;; note: PATH_INFOϴ˥ǥɤƤޤäƤΤǻȤʤ
  (let* ((r (or (cgi-get-metavariable "REQUEST_URI") "/"))
         (m (#/\?/ r))
         )
    (if m
      (m 'before)
      r)))



;;; ----
;;; deprecated


(define cgi-entry->form cgi-entry->html:form)
(define module&cgi-entry->form module&cgi-entry->html:form)



(provide "www/cgi/dispatch-tir")

